diff --git a/isisd/isis_lsp.c b/isisd/isis_lsp.c
index 1ebd35e4973a..6a9eb605f6ed 100644
--- a/isisd/isis_lsp.c
+++ b/isisd/isis_lsp.c
@@ -1134,6 +1134,14 @@ static void lsp_build(struct isis_lsp *lsp, struct isis_area *area)
 
 		cap.router_id.s_addr = area->isis->router_id;
 
+		for (ALL_LIST_ELEMENTS_RO(area->flex_algos->flex_algos, node,
+					  fa)) {
+			if (!fa->advertise_definition)
+				continue;
+			isis_lsp_set_router_capability_fad(
+				area, &cap_fad[fa->algorithm], fa);
+		}
+
 		/* Add SR Sub-TLVs if SR is enabled. */
 		if (area->srdb.enabled) {
 			struct isis_sr_db *srdb = &area->srdb;
@@ -1152,9 +1160,6 @@ static void lsp_build(struct isis_lsp *lsp, struct isis_area *area)
 			for (ALL_LIST_ELEMENTS_RO(area->flex_algos->flex_algos,
 						  node, fa)) {
 				if (fa->advertise_definition) {
-					isis_lsp_set_router_capability_fad(
-						area, &cap_fad[fa->algorithm],
-						fa);
 					rcap_fad = &cap_fad[fa->algorithm];
 				} else
 					rcap_fad = NULL;
